"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeOption = void 0;
const load_compiler_options_1 = require("./load-compiler-options");
const fs_extra_1 = __importDefault(require("fs-extra"));
function normalizeOption(options = {}) {
    var _a, _b, _c, _d;
    const alias = (_a = options.alias) !== null && _a !== void 0 ? _a : {};
    const tsconfigPath = (_b = options.tsconfigPath) !== null && _b !== void 0 ? _b : undefined;
    const tsconfigPathInexist = tsconfigPath && !fs_extra_1.default.existsSync(tsconfigPath);
    if (tsconfigPathInexist) {
        throw new Error(`[esbuild-plugin-alias-path] tsconfig ${tsconfigPath} does not exist.`);
    }
    const compilerOptions = load_compiler_options_1.loadCompilerOptions(tsconfigPath) || {};
    const shouldSkipThisPlugin = (_c = options.skip) !== null && _c !== void 0 ? _c : (!Object.keys(alias).length &&
        !Object.keys((_d = compilerOptions.paths) !== null && _d !== void 0 ? _d : {}).length);
    // TODO:
    // path which is not absolute and not start with ./ or ../ will be regarded as module,
    // and use require.resolve(module) to resolve paths
    // this feature is to support nx json configuration
    // const resolveModule = options?.resolveModule ?? true;
    const normalizedAlias = {};
    // for (const [from, to] of Object.entries(alias)) {
    //   if (
    //     !path.isAbsolute(to) &&
    //     !to.startsWith('.') &&
    //     !to.startsWith('..') &&
    //     resolveModule
    //   ) {
    //     normalizedAlias[from] = require.resolve(to);
    //   } else {
    //     normalizedAlias[from] = to;
    //   }
    // }
    return {
        alias: alias,
        tsconfigPath,
        compilerOptions,
        skip: shouldSkipThisPlugin,
    };
}
exports.normalizeOption = normalizeOption;
